 
/*
   @06-07-2016
   @09-07-2016
   @17-07-2016
   CW callsign generator for Arduino Uno
   Modified by PA3BNX Call PA3JFL
   With parameter Serial message 
   PTT trigger pin
   PTT transmissie output
   tone CW output 
   and CW key output
 */


#include "pitches.h"

// notes in the melody:
int melody[] = {
  NOTE_C4, NOTE_G3, NOTE_G3, NOTE_A3, NOTE_G3, 0, NOTE_B3, NOTE_C4
};

// note durations: 4 = quarter note, 8 = eighth note, etc.:
int noteDurations[] = {
  4, 8, 8, 4, 4, 4, 4, 4
};

//OutPut pins
const byte cPinCW=13;//CW key
const byte cPinCWtone=11; //Only allowed PWM 3,5,6,9,10,11
const byte cPinPTT=3; //PTT tx hold pin Red led 
const byte cPinPTTm=4;//PTT BC547 to Rig


//Input pins
const byte cPinHi=8;//Hi play pin
const byte cPinMelody=9; //Melody play
const byte cPinTrigger=10;//Trigger Remember High = No trigger
const byte cPinMic=5;

//Bool
bool bWatchDog;
bool bStringComplete;

//Integer
int freq;
int stripe;
int dot;
int space;
int separator;
long time;
long startTime; 
long startTime1= millis()+2000;
int x;

//String
String inputString;


void StartMessage()
{
 //Run this for easy StartUp messagwe
 Serial.println(F("Version 1.01"));
 Serial.print(F("Melody trigger pin="));
 Serial.println(cPinMelody);
 Serial.print(F("Hi trigger pin="));
 Serial.println(cPinHi);
 Serial.print(F("CW trigger pin="));
 Serial.println(cPinTrigger);
 Serial.print(F("Melody + Hi + Tone-send bc547 pin="));
 Serial.println(cPinPTTm);
 Serial.print(F("PTT tx busy Red Led pin="));
 Serial.println(cPinPTT);
 Serial.print(F("CW key pin="));
 Serial.println(cPinCW);
 Serial.print(F("CW tone pin="));
 Serial.println(cPinCWtone);
 Serial.print(F("CW tone freq="));
 Serial.println(freq);
 Serial.print(F("Delay sec's="));
 int i = time/1000;
 Serial.println(i);
}

void serialEvent() {
  while (Serial.available()) {
    //get the new byte:
    char inChar=(char)Serial.read();
    // if the incoming character is a newline, set a flag
    // so the main loop can do something about it:
    if (inChar==13||inChar==10||inputString.length() > 6 ){
      bStringComplete=true;
     }
     else
     {
      //add it to the inputString:
      inputString+=inChar;
      inputString.toUpperCase();
    } 
  }
}


void JustTone(int f)
{
 if (f < 32) return;   
 Serial.print(F("Tone="));
 digitalWrite(cPinPTTm,HIGH);
 digitalWrite(cPinPTT,HIGH);
 tone(cPinCWtone,f,2000); 
 delay(2000); 
 digitalWrite(cPinPTT,LOW);
 digitalWrite(cPinPTTm,LOW);
 Serial.println(f);
}

void Melody()
{
  Serial.println(F("Melody"));
  digitalWrite(cPinPTTm,HIGH);
  digitalWrite(cPinPTT,HIGH);
  
  delay(50);
  for (int thisNote = 0; thisNote < 8; thisNote++) {

    // to calculate the note duration, take one second
    // divided by the note type.
    //e.g. quarter note = 1000 / 4, eighth note = 1000/8, etc.
    int noteDuration = 800 / noteDurations[thisNote];
    tone(cPinCWtone, melody[thisNote], noteDuration);

    // to distinguish the notes, set a minimum time between them.
    // the note's duration + 30% seems to work well:
    int pauseBetweenNotes = noteDuration * 1.30;
    delay(pauseBetweenNotes);
    // stop the tone playing:
    noTone(cPinCWtone);
  }
  digitalWrite(cPinPTT,LOW);
  digitalWrite(cPinPTTm,LOW);
}


//Programs


void PTTremote(byte r)
{
  Serial.print(F("PTTremote="));
  Serial.println(r);
  switch(r)
{
case 0:
 digitalWrite(cPinPTTm,LOW);
 bWatchDog=false;
 break;
case 1:
 digitalWrite(cPinPTTm,HIGH);
 bWatchDog=true;
 break;
}
}

void Leader()// 3 x v sein
{
  int f=freq;
  for (int i=0;i<3;i++)
  {
  switch(i){
   case 0:
  freq=NOTE_G5;
  break;
   case 1:
  freq=NOTE_E5;
  break;
  case 2:
  freq=NOTE_C5;
  break;
 default:
  freq=f;
  } 
  Serial.print('v');
  sein(dot);
  sein(dot);
  sein(dot);
  sein(stripe);
  sein(space); 
  }
  sein(separator);
  freq=f; 
}  

void Trailer()
{
byte z=50;  
int i;
for (i=-150;i<50;i+=15)
{
 if (i<0)
  {
   tone(cPinCWtone,freq+i,z);
  }
 else
 {
  tone(cPinCWtone,freq-i,z);
 }
 delay(z-10);
}
 
 sein(space);
 tone(cPinCWtone,freq,space);
 sein(space);

}

void Mic()
{
Serial.println(F("Mic"));
byte i= 80;
byte j= 150;
digitalWrite(cPinPTT,HIGH);
tone(cPinCWtone,NOTE_C4,i);
delay(j);
tone(cPinCWtone,NOTE_C4,i);
delay(j);
tone(cPinCWtone,NOTE_F4,i);
delay(j);
tone(cPinCWtone,NOTE_F4,i);
delay(j);
tone(cPinCWtone,NOTE_D4,i);
delay(j);
tone(cPinCWtone,NOTE_D4,i);
delay(j);
tone(cPinCWtone,NOTE_C4,i);
delay(j);
//tone(cPinCWtone,NOTE_D4,100);
//delay(105);
//tone(cPinCWtone,NOTE_C4,100);
//delay(105);

digitalWrite(cPinPTT,LOW);
}

void Hi()
{
Serial.println(F("HI"));
digitalWrite(cPinPTTm,HIGH);
digitalWrite(cPinPTT,HIGH); 
delay(50);  
sein(dot);
sein(dot);
sein(dot);
sein(dot);
sein(space);
sein(dot);
sein(dot);
sein(separator);
digitalWrite(cPinPTT,LOW);
digitalWrite(cPinPTTm,LOW);
}

void Callsign(bool b)
{

 if (b==true) {digitalWrite(cPinPTTm,HIGH);} 
 digitalWrite(cPinPTT,HIGH); 


x += 1;
digitalWrite(cPinPTT,HIGH);//Switch PTT on
Serial.print (x);
Serial.print(' ');
delay(dot);


Leader();
  
  //p 
Serial.print(F(" p"));
sein(dot);
sein(stripe);
sein(stripe);
sein(dot);
sein(space);

//a
Serial.print('a');
sein(dot);
sein(stripe);
sein(space); 

//3
Serial.print('3');
sein(dot);
sein(dot);
sein(dot);
sein(stripe);
sein(stripe);
sein(space);

//b
Serial.print('b');
sein(stripe);
sein(dot);
sein(dot);
sein(dot);
sein (space);

//n
Serial.print('n');
sein(stripe);
sein(dot);
sein(space);

//x
Serial.println('x');
sein(stripe);
sein(dot);
sein(dot);
sein(stripe);
sein(separator);

Trailer();

digitalWrite(cPinPTT,LOW);
if (b==true){digitalWrite(cPinPTTm,LOW);}  
}//Last Callsign

void Speed(int s)
{
  dot=s;
  stripe=3 * dot;
  space=4 * dot;
  separator=6 * dot;
}  

void sein(int token)
{
if (token==space)
{   
 delay(space);
 }
  else if (token==separator)
  {
  delay(separator);
  }  
  else
  {
  //freq= 200 + (analogRead(A0)* 2);
  digitalWrite(cPinCW,HIGH);
  tone(cPinCWtone,freq,token);
  delay(token);
  digitalWrite(cPinCW,LOW);
  delay(dot);
  }
 }

// Initialise
void setup() {
   Serial.begin(9600);
   //initialise port cPins
   pinMode(cPinCW, OUTPUT);
   pinMode(cPinPTT,OUTPUT);
   pinMode(cPinTrigger,INPUT_PULLUP);
   pinMode(cPinMelody,INPUT_PULLUP);
   pinMode(cPinHi,INPUT_PULLUP);
   pinMode(cPinMic,INPUT); 
  
  Speed(60);
  freq = NOTE_G5;
  //time = 300000;  //mSecondes
  time = 300000;
  startTime=millis()+time;
  StartMessage();
}

// start loop
void loop() {
 
//Now the delay ca 1800000mSec or 180Sec
//time * dot mSec
  
  
  
//Main time loop   
  
  long TimeNow = millis();
  
  if (startTime < TimeNow) 
  {
   if (bWatchDog==true){PTTremote(0);}//Reset if to long on
   Callsign(false);
   startTime = millis()+time;
  }
  
  //goto endje;
  
  
  //Serial input Just every 2 sec orso ?
  if (startTime1 < TimeNow)
   {
   serialEvent();  
   if (bStringComplete==true)
   {
      
    
    if (inputString=="1")
    {
     PTTremote(1);
    }
    else if (inputString=="0")
    {
     PTTremote(0);
    }  
    else if (inputString.indexOf("HZ"))
    {
      JustTone(inputString.toInt());
    }
     //Serial.println(inputString);       
     inputString="";
     bStringComplete=false;
     startTime1= millis()+2000;   
  }  
}
   
   //Voter routine   
   for (int j=0;j<1000;j++)
   {
   if (digitalRead(cPinMelody)==LOW){Melody();startTime=millis()+time;break;}
   if (digitalRead(cPinHi)==LOW){Hi();startTime=millis()+time;break;}  
   if (digitalRead(cPinTrigger)==LOW){Callsign(true);startTime=millis()+time;break;}
   if (digitalRead(cPinMic)==LOW){Mic();startTime=millis()+time;break;}
   delayMicroseconds(1); 
   }
    
   
//endje:   

} //end of loop
